<script lang="ts">
import Vue from 'vue';
import SoftwareFasterVideoModal from './software-faster-video-modal.vue';

export default Vue.extend({
  components: {
    SoftwareFasterVideoModal,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      isModalVisible: false,
    };
  },
  watch: {
    isModalVisible(newValue) {
      if (newValue) {
        document.querySelector('body')?.classList.add('noScroll');
      } else {
        document.querySelector('body')?.classList.remove('noScroll');
        const video =
          this.$refs.heroModal.querySelector('lite-vimeo').contentWindow;
        if (video) {
          video.postMessage('{"method":"pause"}', '*');
        }
      }
    },
  },
  methods: {
    showModal() {
      this.isModalVisible = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    closeModal() {
      this.isModalVisible = false;
    },
  },
});
</script>
<template>
  <div class="hero">
    <div class="hero__image-container">
      <img class="hero__bg-image" :src="data.image.url" preload />
      <SlpContainer class="hero__container">
        <SlpRow class="hero__row">
          <SlpColumn :cols="8" size="md" class="hero__copy hero__col">
            <div
              :data-aos="data?.aos_animation ? data.aos_animation : 'fade-down'"
              :data-aos-duration="data?.aos_duration ? data.aos_duration : 1600"
              :data-aos-offset="data?.aos_offset ? data.aos_offset : 0"
            >
              <SlpTypography tag="h1" variant="display1" class="title">
                {{ data.title }}
              </SlpTypography>
              <SlpTypography
                tag="p"
                variant="heading4"
                class="slp-pt-24 description"
              >
                {{ data.subtitle }}
              </SlpTypography>
              <SlpButton
                v-if="data.button"
                :href="data.button.href"
                variant="secondary"
                :data-ga-name="data.button.data_ga_name"
                :data-ga-location="data.button.data_ga_location"
                class="slp-mt-24 slp-mr-24"
              >
                {{ data.button.text }}
              </SlpButton>
              <SlpButton
                v-if="data.secondary_button"
                variant="tertiary"
                class="slp-mt-24 secondary-button"
                :data-ga-name="data.secondary_button.data_ga_name"
                :data-ga-location="data.secondary_button.data_ga_location"
                @click.native="showModal"
              >
                {{ data.secondary_button.text }}
                <svg
                  width="16"
                  height="16"
                  viewBox="0 0 16 16"
                  fill="none"
                  xmlns="http://www.w3.org/2000/svg"
                >
                  <path
                    d="M14.875 7.875C14.875 4.01042 11.7396 0.875 7.875 0.875C4.01042 0.875 0.875 4.01042 0.875 7.875C0.875 11.7396 4.01042 14.875 7.875 14.875C11.7396 14.875 14.875 11.7396 14.875 7.875Z"
                    stroke="white"
                    stroke-width="1.5"
                    stroke-miterlimit="10"
                    fill="transparent"
                  />
                  <path
                    d="M6.42834 10.7348L10.601 8.21404C10.6592 8.17861 10.7072 8.12881 10.7406 8.06943C10.7739 8.01005 10.7915 7.94309 10.7915 7.87498C10.7915 7.80687 10.7739 7.73991 10.7406 7.68053C10.7072 7.62115 10.6592 7.57135 10.601 7.53592L6.42834 5.01519C6.36853 4.97936 6.30026 4.96008 6.23054 4.95934C6.16083 4.95859 6.09216 4.97641 6.0316 5.01095C5.97104 5.0455 5.92076 5.09554 5.88592 5.15593C5.85108 5.21632 5.83293 5.28489 5.83333 5.35462V10.3954C5.83293 10.4651 5.85108 10.5337 5.88592 10.594C5.92076 10.6544 5.97104 10.7045 6.0316 10.739C6.09216 10.7736 6.16083 10.7914 6.23054 10.7906C6.30026 10.7899 6.36853 10.7706 6.42834 10.7348Z"
                    fill="white"
                  />
                </svg>
              </SlpButton>
            </div>
          </SlpColumn>
          <SlpColumn
            :cols="4"
            size="md"
            class="hero__col"
            :data-aos="
              data?.image.aos_animation ? data.image.aos_animation : 'fade-up'
            "
            :data-aos-duration="
              data?.image.aos_duration ? data.image.aos_duration : 1600
            "
            :data-aos-offset="
              data?.image.aos_offset ? data.image.aos_offset : 0
            "
          >
          </SlpColumn>
        </SlpRow>
        <div
          v-show="isModalVisible"
          ref="heroModal"
          class="modal__backdrop"
          @click.self="closeModal"
        >
          <SoftwareFasterVideoModal
            :video-url="data.secondary_button.video_url"
            @close="closeModal"
          />
        </div>
      </SlpContainer>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.hero {
  &__row {
    position: absolute;
    transform: translateY(-50%);
    top: 50%;
  }

  &__bg-image {
    width: 100%;

    @media (max-width: $breakpoint-lg) {
      min-height: 300px;
      object-fit: cover;
    }
  }

  &__image-container {
    position: relative;
  }

  &__col {
    height: 100%;
    min-height: 100%;
    width: 100%;
    position: relative;

    @media (max-width: $breakpoint-lg) {
      flex: 1 1 100%;
      width: 100%;
    }
  }

  &__copy {
    padding: $spacing-64 0;
    z-index: 1000;
  }
}

.title {
  color: white;
  padding-bottom: $spacing-8;

  @media (min-width: 577px) and (max-width: 1029px) {
    font-size: 70px;
    line-height: 80px;
  }
}

.secondary-button {
  color: $color-text-50;
  padding: $spacing-8 $spacing-16;
  border: 2px solid transparent;
  border-radius: 4px;
  background:
    linear-gradient($color-primary-200, $color-primary-200) padding-box,
    linear-gradient(
        159.09deg,
        #f6cdbe 0.37%,
        #f8f5ff 22.79%,
        #ffffff 44.56%,
        #e2d2f1 78.43%,
        #ffd4d8 109.47%
      )
      border-box;

  &:hover {
    text-decoration: underline;

    svg {
      transition: transform 0.4s ease;
      transform: translateX($spacing-8);
    }
  }

  svg {
    margin-left: $spacing-8;
  }
}

.modal {
  background: transparent;
  display: flex;
  flex-direction: column;
  margin-top: $spacing-160;

  &__backdrop {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba($color-surface-700, 0.85);
    display: flex;
    justify-content: center;
    align-items: flex-start;
    z-index: 1040;
  }
}
</style>
